/*
  Calisto - An internet Talker
  Copyright (C) 1998-2001 Peter Howkins, Matthew Howkins and Simon Howkins

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,     
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License   
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Email: calisto@calisto.cx

  $Id: dllist.c,v 1.2 2000/12/29 20:53:22 peter Exp $

 */
static const char rcsid[] = "$Id: dllist.c,v 1.2 2000/12/29 20:53:22 peter Exp $";

#include "dllist.h"

unsigned list_len(const listhead *lh)
{
  int i = 0;
  listnode *l = lh->head.next;

  while (LIST_NODE_IS_REAL(l) ) {
    i++;
    l = l->next;
  }
  return i;
}

void list_qsort_n(listnode *pivot,
                  int (cmp)(const listnode *,
                            const listnode *),
                  unsigned len)
{
  listnode *before = pivot->prev;
  listnode *l = pivot->next;
  unsigned i;
  unsigned moved = 0;

  if (len == 0 || len == 1)
    return;

  for (i = 0; i < len - 1; i++) {
    listnode *n = l->next;
    if (cmp(l, pivot) < 0) {
      LIST_UNLINK_NODE(l);
      LIST_LINK_NODE_BEFORE(l, pivot);
      moved++;
    }
    l = n;
  }
  list_qsort_n(before->next, cmp, moved);
  list_qsort_n(pivot->next, cmp, len - moved - 1);
}

void list_qsort(listhead *head,
                  int (cmp)(const listnode *,
                            const listnode *) )
{
  if (!LIST_IS_EMPTY(*head) )
    list_qsort_n(head->head.next, cmp, list_len(head) );
}
