#include <stdlib.h>

#include "pstruct.h"

void on_init(void);
void on_shutdown(void);
void command_social(character *, char *, const char *, void *);   

unsigned pversion = 1;

struct pheader p = {
  "Socials",
  1,
  "Flibble",
  NULL,
  0,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  on_init,
  on_shutdown,
  "socials.hlp"
}; 

/* multiple send to room except func */
static void send_to_room_except_except(const char *group, const character *c,
                                const character *d, const char *string, ...)
{
  listnode *pNode = AllPlayers.head.next;
  char buffer[OUTPUT_BUFFER];
  va_list ptr;
       
  va_start(ptr, string);
  mvsnprintf(buffer, sizeof(buffer), string, ptr);
  va_end(ptr);
    
  while (LIST_NODE_IS_REAL(pNode)) {
    character *pChar = LIST_GET_DATA(pNode,character*,characterlink);
    if(pChar != c && pChar != d) {
      if(STREQ(group, pChar->group)) {
        send_to_char(pChar, buffer);
      }
    }
    pNode = pNode->next;
  }
}   

struct social_messg *soc_start;

struct social_messg {
  int act_nr;                                            /* !needed */ 
  int hide;                                              /* !needed */
  int min_victim_position;      /* Position of victim */ /* !needed */

  /* added by flibble */
  char *name;  /* the name of the social eg fart */

  /* No argument was supplied */
  char *char_no_arg;
  char *others_no_arg;   

  /* An argument was there, and a victim was found */
  char *char_found;             /* if NULL, read no further, ignore args */
  char *others_found;
  char *vict_found;

  /* An argument was there, but no victim was found */
  char *not_found;

  /* The victim turned out to be the character */
  char *char_auto;
  char *others_auto;
};


char *read_action(char *buf)
{
  if(STREQ(buf, "#")) {
    return NULL;
  }

  return STRDUP(buf);
}

static int soc_line = 0;

void do_soc(char *line, command *cpointer, struct social_messg *soc_pointer)
{
  char buf[100];
  int dump, dump2;

  soc_line++;
  switch(soc_line) {
    case 1:
      sscanf(line, " %s  %d %d ", buf, &dump, &dump2);
      cpointer->name = STRDUP(buf);
      cpointer->shortcut = STRDUP(""); 
      cpointer->privname = STRDUP("n_base");
      cpointer->function = command_social;
      soc_pointer->name = STRDUP(buf);
      break;
    case 2:
      /* to char - no argument */ 
      soc_pointer->char_no_arg = read_action(line);
      break;
    case 3:
      /* to room - no argument */ 
      soc_pointer->others_no_arg = read_action(line);
      break;
    case 4:
      /* to char, victim found */
      soc_pointer->char_found = read_action(line);
      break;
    case 5:
      /* to room, victim found */
      soc_pointer->others_found = read_action(line);
      break;
    case 6:
      /* to victim, victim found */
      soc_pointer->vict_found = read_action(line);
      break;
    case 7:
      /* to char, victim not found */
      soc_pointer->not_found = read_action(line);
      break;
    case 8:
      /* to char, if victim is char */
      soc_pointer->char_auto = read_action(line);
      break;
    case 9:
      /* to room, if victim is char */
      soc_pointer->others_auto = read_action(line);
      break;
    default: 
      break;
  }
}

void commit_soc(command *cpointer, struct social_messg *soc_pointer)
{
  /* if a 'short' social blank out unused fields */
  if(soc_line == 3) {
      soc_pointer->char_found   = NULL;
      soc_pointer->others_found = NULL;
      soc_pointer->vict_found   = NULL;
      soc_pointer->not_found    = NULL;
      soc_pointer->char_auto    = NULL;
      soc_pointer->others_auto  = NULL;
  }
  soc_line = 0;
}

void on_init(void)
{
  /* open up socials file.
     find number of socials
     setup commands
      malloc space (num * sizeof(command);
      fill in details.
     setup social struct
      malloc space (sizeof file);
      set char * pointers to correct place
   */
  FILE *fl;
  char buf[1024];
  unsigned num = 0;
  command *cstart, *cpointer;
  struct social_messg *soc_pointer;

  if(!(fl = fopen("./plugins/socials.dat", "r"))) {
    log(usage, "Error opening  ./plugins/socials.dat");
    fprintf(stderr, "Error opening ./plugins/socials.dat\n");
    return;
  }

  /* count socials */
  while(fgets(buf, sizeof(buf), fl)) {
    strchomp(buf);
    if(STREQ(buf, ""))
      num++;
  }

  /* malloc space for commands, and socials */
  cpointer = MEM_MALLOC(sizeof(command) * (num + 1));
  soc_pointer = MEM_MALLOC(sizeof(struct social_messg) * (num + 1));
  /* remember where the first command in the block is */
  cstart = cpointer;
  soc_start  = soc_pointer;

  /* read them in */
  rewind(fl);
  while(fgets(buf, sizeof(buf), fl)) {
    strchomp(buf);
    /* in circle, end of data file is written with a $, prolly not needed
       here though */
    if(STREQ(buf, "$")) {
      break;
    }
    if(STREQ(buf, "")) {
      commit_soc(cpointer, soc_pointer);
      cpointer++;
      soc_pointer++;
    } else {
      do_soc(buf, cpointer, soc_pointer);
    }
  }
 
  fclose(fl);

  /* terminate the command struct */
  cpointer->name = NULL;
  cpointer->shortcut = NULL;
  cpointer->function = NULL;
  cpointer->privname = NULL;

  /* terminate social messg list */
  soc_pointer->name = NULL;

  p.clist = cstart;  
}

void on_shutdown(void)
{
/*  struct social_messg *soc = soc_start;

  fprintf(stderr, "about to free up one soc\n");
  while(soc != NULL) {
    if(soc->name)
      MEM_FREE(soc->name);
    if(soc->char_no_arg)
      MEM_FREE(soc->char_no_arg);
    if(soc->others_no_arg)
      MEM_FREE(soc->others_no_arg);   
    if(soc->char_found)
      MEM_FREE(soc->char_found);
    if(soc->others_found)
      MEM_FREE(soc->others_found);
    if(soc->vict_found)
      MEM_FREE(soc->vict_found);
    if(soc->not_found)
      MEM_FREE(soc->not_found);
    if(soc->char_auto)
      MEM_FREE(soc->char_auto);
    if(soc->others_auto)
      MEM_FREE(soc->others_auto);
    soc++;
  }
*/
  fprintf(stderr, "about to free up all socs\n");
  MEM_FREE(soc_start);
}

char *social_sub(char *mess, char *buff, size_t buffsize, character *ch,
                 character *vict)
{
  int len = 0;
  char *b = buff;
  char *i = NULL;

  while(*mess && len < buffsize) {
    if(*mess == '$') {
      mess++;
      if(*mess == 'n') {
        if(ch) {
          i = GETNAME(ch);
        } else {
          i = "<error>";
        }
      } else if(*mess == 'm') {
        i = "them";
      } else if(*mess == 's') {
        i = "their";
      } else if(*mess == 'N') {
        if(vict) {
          i = GETNAME(vict);
        } else { 
          i = "<error>";
        }
      } else if(*mess == 'M') {
        i = "them";
      } else if(*mess == 'S') {
        i = "their";
      }
      while(*i && len < buffsize) {
        *b++ = *i++;
        len++;
      }
      mess++;
    } else {
      *b++ = *mess++;
      len++;
    }
  }

  *b = '\0';

  return buff;
}

void command_social(character *c, char *r, const char *comm, void *s)
{
  struct social_messg *social;
  char buff[1024];
  character *vict;

  social = soc_start;

  /* find the social */
  while(social) {
    if(STREQ(comm, social->name)) {
      break;
    }
    social++;
  }
  if(!social) {
    /* hmm this is a bad thing */
    log(debug, "Command attempting to call social not in social list");
    send_to_char(c, "Something bad has happened, don't worry your little head over it though\n");
    return;
  }

  if(STREQ(r, "")) {
    /* no victim social */
    if(social->char_no_arg != NULL) {
      send_to_char(c, "%s\n", social_sub(social->char_no_arg, buff,
                                         sizeof(buff), c, NULL));
    }
    if(social->others_no_arg != NULL) {
      send_to_room_except(GETGROUP(c), c, "%s\n", social_sub(social->others_no_arg,
                                                 buff, sizeof(buff), c, NULL));
    }
    return;
  }
  vict = character_from_name(r);
  if(!vict) {
    /* victim not found */
    if(social->not_found != NULL) {
      send_to_char(c, "%s\n", social_sub(social->not_found, buff,
                                         sizeof(buff), c, NULL));
    }
    return;
  } else {
    if(vict == c) {
      /* character has done social on self */
      if(social->char_auto != NULL) {
        send_to_char(c, "%s\n", social_sub(social->char_auto, buff,
                                         sizeof(buff), c, vict));
      }
      if(social->others_auto != NULL) {
        send_to_room_except(c->group, c, "%s\n", social_sub(social->others_auto,
                                         buff, sizeof(buff), c, vict));
      }
      return;
    } else {
      /* hurrah a properly targetted social */
      if(social->char_found != NULL) {
        send_to_char(c, "%s\n", social_sub(social->char_found, buff,
                                         sizeof(buff), c, vict));
      }
      if(social->others_found != NULL) {
        send_to_room_except_except(c->group, c, vict, "%s\n",
                                   social_sub(social->others_found, buff,
                                              sizeof(buff), c, vict));
      }
      if(social->vict_found != NULL) {
        do_tell(vict, "%s\n", social_sub(social->vict_found,
                                         buff, sizeof(buff), c, vict));
      }
      return;
    }
  }
}

